//
//  ViewController.swift
//  AppExtensionEx
//
//  Created by MB KWON on 2014. 8. 29..
//  Copyright (c) 2014년 UANGEL Corp. All rights reserved.
//

import UIKit

class ViewController: UIViewController, UITableViewDataSource, UITableViewDelegate {
    
    var keys:Keys = Keys()
    struct Keys {
        var appGroupKey = "group.TodayString"
        var userDefaultKey = "todayStringList"
        var tableViewCellKey = "todayStringCell"
    }
    
    @IBOutlet weak var textInput:UITextField?
    @IBOutlet weak var tableView:UITableView?
    
    
    var stringListOnToday: Array<String> = []{
        
        didSet {
            
            userDefault.setObject(stringListOnToday, forKey: keys.userDefaultKey)
            userDefault.synchronize()
            tableView?.reloadData()
        }
    }
    
    var userDefault: NSUserDefaults {
        return NSUserDefaults(suiteName: keys.appGroupKey)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
        if let stringList: AnyObject = userDefault.objectForKey(keys.userDefaultKey) {
            stringListOnToday = stringList as Array<String>
            tableView?.reloadData()
        }
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    @IBAction func dismissTextInputKeyboard() {
        if let textfield = textInput {
            textfield.resignFirstResponder()
        }
    }
    
    @IBAction func inputTextOnToday() {
        if let textfield = textInput {
            
            if countElements(textfield.text) > 0 {
                stringListOnToday.append(textfield.text)
                textInput?.text = ""
            }
        }
    }
    
    
    func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return stringListOnToday.count
    }
    
    func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        var cell:UITableViewCell! = tableView.dequeueReusableCellWithIdentifier(keys.tableViewCellKey) as? UITableViewCell
        
        if cell == nil {
            cell = UITableViewCell(style: UITableViewCellStyle.Default, reuseIdentifier: keys.tableViewCellKey)
        }
        
        cell.textLabel?.text = stringListOnToday[indexPath.row]
        
        return cell
    }
    
    func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath!) {
    
        var cell:UITableViewCell? = tableView.cellForRowAtIndexPath(indexPath)
        
        if let tempCell = cell {
            tempCell.selected = false
            
            var alertController: UIAlertController = UIAlertController(title: "어록", message: tempCell.textLabel?.text, preferredStyle: UIAlertControllerStyle.Alert)
            alertController.addAction(UIAlertAction(title: "확인", style: UIAlertActionStyle.Default, handler: {
                
                (action) -> Void in
                alertController.dismissViewControllerAnimated(true, completion: nil)
            }))
            
            presentViewController(alertController, animated: true, completion: nil)
        }
    }
    
    
    func tableView(tableView: UITableView, editingStyleForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCellEditingStyle {
        return UITableViewCellEditingStyle.Delete
    }
    
    func tableView(tableView: UITableView, canEditRowAtIndexPath indexPath: NSIndexPath) -> Bool {
        return true
    }
    
    func tableView(tableView: UITableView, titleForDeleteConfirmationButtonForRowAtIndexPath indexPath: NSIndexPath) -> String! {
        return "삭제"
    }
    
    func tableView(tableView: UITableView, commitEditingStyle editingStyle: UITableViewCellEditingStyle, forRowAtIndexPath indexPath: NSIndexPath) {
        
        var cell:UITableViewCell? = tableView.cellForRowAtIndexPath(indexPath)
        
        if let tempCell = cell {
            
            var cellString = cell?.textLabel?.text
            if let tempString = cellString {
                
                var index = 0
                for todayString in stringListOnToday {
                    if todayString == tempString {
                        stringListOnToday.removeAtIndex(index)
                        break
                    }
                    
                    index++
                }
            }
        }
    }
}

