//
//  TodayViewController.swift
//  TodayWidgetEx
//
//  Created by MB KWON on 2014. 8. 29..
//  Copyright (c) 2014년 UANGEL Corp. All rights reserved.
//

import UIKit
import NotificationCenter

class TodayViewController: UIViewController, NCWidgetProviding {
    
    var keys:Keys = Keys()
    struct Keys {
        var appGroupKey = "group.TodayString"
        var userDefaultKey = "todayStringList"
        var tableViewCellKey = "todayStringCell"
    }
    
    @IBOutlet weak var todayStringLabel: UILabel?
    var userDefault: NSUserDefaults {
        return NSUserDefaults(suiteName: keys.appGroupKey)
    }
    
    var toayStringOnWidget: String {
        
        get {
            
            if let stringList: AnyObject = userDefault.objectForKey(keys.userDefaultKey) {
                var todayStringList:Array<String> = stringList as Array<String>
                
                var ranNum: Int = Int(rand())
                var stringCount: Int = countElements(todayStringList)
                
                if stringCount > 0 {
                    return todayStringList[ranNum % stringCount]
                }
                
            }
            
            return "입력된 문장이 없습니다"
        }
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view from its nib.
    }
    
    func widgetPerformUpdateWithCompletionHandler(completionHandler: ((NCUpdateResult) -> Void)!) {
        // Perform any setup necessary in order to update the view.
        
        // If an error is encoutered, use NCUpdateResult.Failed
        // If there's no update required, use NCUpdateResult.NoData
        // If there's an update, use NCUpdateResult.NewData
        
        todayStringLabel?.text = toayStringOnWidget
        completionHandler(.NewData)
    }
    
    func widgetMarginInsetsForProposedMarginInsets(defaultMarginInsets: UIEdgeInsets) -> UIEdgeInsets {
        let margin:UIEdgeInsets = UIEdgeInsetsMake(5, 0, 5, 0)
        
        return margin
    }
    
    @IBAction func touchWidget() {
        let urlSheme = NSURL(scheme: "TestTodayString", host: nil, path: "/")
        
        extensionContext?.openURL(urlSheme, completionHandler: nil)
    }
}
